VOP_SETACL(9) | Kernel Developer's Manual | VOP_SETACL(9)

# NAME

`VOP_SETACL` — set the access control list for a vnode

# SYNOPSIS

`#include <sys/param.h>`
`#include <sys/vnode.h>`
`#include <sys/acl.h>`

int
`VOP_SETACL`(struct vnode *vp, acl_type_t type, struct acl *aclp, kauth_cred_t cred);

# DESCRIPTION

This vnode call may be used to set the access control list (ACL) for a file or directory.

Its arguments are:

vp
  The vnode of the file or directory.
type
  The type of ACL to set.
aclp
  A pointer to an ACL structure from which to retrieve the ACL data.
cred
  The user credentials to use in authorizing the request.

The aclp pointer may be `NULL` to indicate that the specified ACL should be deleted.

The cred pointer may be `NULL` to indicate that access control checks are not to be performed, if possible. This cred setting might be used to allow the kernel to authorize ACL changes that the active process might not be permitted to make.

The vnode ACL interface defines the syntax, and not semantics, of file and directory ACL interfaces. More information about ACL management in kernel may be found in acl(9).

# LOCKS

The vnode will be locked on entry and should remain locked on return.

# RETURN VALUES

If the ACL is successfully set, then zero is returned. Otherwise, an appropriate error code is returned.

# ERRORS

[`EACCES`]
  The caller does not have the appropriate privilege.
[`EINVAL`]
  The ACL type passed is invalid for this vnode, or the ACL data is invalid.
[`ENOMEM`]
  Sufficient memory is not available to fulfill the request.
[`ENOSPC`]
  The file system is out of space.
[`EOPNOTSUPP`]
  The file system does not support `VOP_SETACL`().
[`EROFS`]
  The file system is read-only.

# SEE ALSO

acl(9), vnode(9), VOP_ACLCHECK(9), VOP_GETACL(9)

# AUTHORS

This manual page was written by Robert Watson.

January 17, 2022 | NetBSD 11.0